#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link "http://www.metaquotes.net"

extern   double   Lots = 0.1;
extern   int      ReadHistory = 1;
extern   double   Probab = 0.8;
extern   int      dstop = 25;
extern   int      Nstop = 1;
extern   int      delta = 1;
extern   int      Nidelt = 20;
extern   int      NN = 10;
extern   double   forg = 1.05;
extern   bool     ReplaceStops = true;
extern   double   lTrailingStop = 510;
extern   double   sTrailingStop = 510;
int      Magic;
int      var_148;
int      var_152;
int      var_156;
int      var_160;
int      var_164;
int      fh;
int      i;
int      j;
int      k;
int      TakeProfit;
int      StopLoss;
int      var_192;
int      var_196;
int      ticket;
int      NeedModifyBuy;
int      NeedModifySell;
int      NeedCloseBuy;
int      NeedCloseSell;
int      var_220;
int      var_224;
int      FirstTime;
int      var_232;
double   var_236;
double   var_244;
double   var_252;
double   var_260;
double   var_268;
double   var_276;
double   var_284;
string   FileName;
int      arr_300[30];
int      arr_304[50,30];
int      arr_308[5000,30,3];
int      arr_312[3];
int      arr_316[5000,30,3];
double   arr_320[12,30];
double   arr_324[30];
double   arr_328[5000,30,3];
double   arr_332[5000,30,3];
double   arr_336[5000,30,3];
double   arr_340[5000,30,3];

//+------------------------------------------------------------------+

int init()
{
Magic = Period() + 796385000;

for (i = 1; i <= Nidelt; i++)
   {
   arr_300[i] = delta * i;
   for (j = 1; j <= NN - 1; j++)
      {
      arr_320[j,i] = Close[j - 1];
      }
   }
return(0);
}

//+------------------------------------------------------------------+

int deinit()
{
return(0);
}

//+------------------------------------------------------------------+

int start()
{
int ordtotal;

//if (FirstTime == 0)
//   {
//   Alert("-     ");
//   FirstTime = 1;
//   }
//
//if (IsTesting() == false) return(0);

NeedModifyBuy = 0;
NeedModifySell = 0;
NeedCloseBuy = 0;
NeedCloseSell = 0;

if (ReadHistory == 0) var_232 = 1;
if ((Bars < 205) || (AccountFreeMargin() < 10)) return(0);

for (i = 1; i <= Nidelt; i++)
   {
   arr_300[i] = delta * i;
   if (MathAbs(Ask - arr_320[1,i]) > (arr_300[i] - 0.5) * Point)
      {
      for (j = 1; j <= NN - 1; j++)
         {
         arr_320[NN + 1 - j,i] = arr_320[NN - j,i];
         }
      arr_320[1,i] = Ask;
      }
   if (MathAbs(arr_320[1,i] - arr_324[i]) > Point / 2)
      {
      for (j = 1; j <= NN - 1; j++)
         {
         if (arr_320[j,i] > arr_320[j + 1,i]) arr_304[j,i] = 1; else arr_304[j,i] = 0;
         }
      var_152 = 0;
      var_148 = 1;
      for (j = 1; j <= NN - 1; j++)
         {
         var_152 = var_152 + var_148 * arr_304[j,i];
         var_148 = var_148 * 2;
         }
      for (k = 1; k <= Nstop; k++)
         {
         if ((arr_308[var_152,i,k] == 0) && (TimeCurrent() - arr_340[var_152,i,k] > Period() * 2 * 60))
            {
            arr_308[var_152,i,k] = 1;
            arr_328[var_152,i,k] = Ask;
            arr_340[var_152,i,k] = TimeCurrent();
            }
         }
      for (k = 1; k <= Nstop; k++)
         {
         arr_312[k] = dstop * k;
         for (j = 0; j <= var_148 - 1; j++)
            {
            if (arr_308[j,i,k] == 1)
               {
               if (Ask - arr_328[j,i,k] > arr_312[k] * Point)
                  {
                  arr_332[j,i,k] = arr_332[j,i,k] / forg + 1.0;
                  arr_336[j,i,k] = arr_336[j,i,k] / forg;
                  arr_308[j,i,k] = 0;
                  arr_316[j,i,k] = arr_316[j,i,k] + 1;
                  }
               if (arr_328[j,i,k] - Ask > arr_312[k] * Point)
                  {
                  arr_336[j,i,k] = arr_336[j,i,k] / forg + 1.0;
                  arr_332[j,i,k] = arr_332[j,i,k] / forg;
                  arr_308[j,i,k] = 0;
                  arr_316[j,i,k] = arr_316[j,i,k] + 1;
                  }
               }
            }
         }
      for (k = 1; k <= Nstop; k++)
         {
         arr_312[k] = dstop * k;
         var_244 = arr_332[var_152,i,k] / (arr_332[var_152,i,k] + arr_336[var_152,i,k] + 0.0001);
         if ((var_244 > Probab) && (arr_316[var_152,i,k] > 10) && (TimeCurrent() - var_276 > Period() * 2 * 60))
            {
            TakeProfit = arr_312[k];
            StopLoss = arr_312[k];
            NeedModifyBuy = 1;
            ordtotal = OrdersTotal();
            for (j = 0; j < ordtotal; j++)
               {
               if (MyOrder(j))
                  {
                  if (OrderType() == OP_SELL)
                     {
                     FileName = "FDlast_sell" + Symbol() + Period();
                     fh = FileOpen(FileName,FILE_CSV|FILE_READ);
                     var_252 = FileReadNumber(fh);
                     if (var_244 > var_252 + 0.05) NeedCloseSell = 1;
                     FileClose(fh);
                     }
                  }
               }
            FileName = "FDlast_buy" + Symbol() + Period();
            fh = FileOpen(FileName,FILE_CSV|FILE_WRITE);
            FileWrite(fh,var_244);
            FileClose(fh);
            }
         ordtotal = OrdersTotal();
         for (j = 0; j < ordtotal; j++)
            {
            if (MyOrder(j))
               {
               if (OrderType() == OP_SELL)
                  {
                  if ((var_244 > 0.6) && (arr_316[var_152,i,k] > 10) && (OrderOpenPrice() - Ask > dstop / 2 * Point))
                     {
                     NeedCloseSell = 1;
                     }
                  }
               }
            }
         var_244 = arr_336[var_152,i,k] / (arr_332[var_152,i,k] + arr_336[var_152,i,k] + 0.0001);
         if ((var_244 > Probab) && (arr_316[var_152,i,k] > 10) && (TimeCurrent() - var_284 > Period() * 2 * 60))
            {
            TakeProfit = arr_312[k];
            StopLoss = arr_312[k];
            NeedModifySell = 1;
            ordtotal = OrdersTotal();
            for (j = 0; j < ordtotal; j++)
               {
               if (MyOrder(j))
                  {
                  if (OrderType() == OP_BUY)
                     {
                     FileName = "FDlast_buy" + Symbol() + Period();
                     fh = FileOpen(FileName,FILE_CSV|FILE_READ);
                     var_252 = FileReadNumber(fh);
                     if (var_244 > var_252 + 0.05) NeedCloseBuy = 1;
                     FileClose(fh);
                     }
                  }
               }
            FileName = "FDlast_sell" + Symbol() + Period();
            fh = FileOpen(FileName,FILE_CSV|FILE_WRITE);
            FileWrite(fh,var_244);
            FileClose(fh);
            }
         ordtotal = OrdersTotal();
         for (j = 0; j < ordtotal; j++)
            {
            if (MyOrder(j))
               {
               if (OrderType() == OP_BUY)
                  {
                  if ((var_244 > 0.6) && (arr_316[var_152,i,k] > 10) && (Bid - OrderOpenPrice() > dstop / 2 * Point))
                     {
                     NeedCloseBuy = 1;
                     }
                  }
               }
            }
         }
      var_156 = var_156 + 1;
      }
   arr_324[i] = arr_320[1,i];
   }

if (var_160 == 0)
   {
   FileName = "FD_" + Symbol();
   var_160 = 1;
   fh = FileOpen(FileName,FILE_CSV|FILE_READ);
   var_164 = FileReadNumber(fh);
   var_236 = FileReadNumber(fh);
   if ((var_164 == 1) && (ReadHistory == 1) && (var_232 != 1))
      {
      for (k = 1; k <= Nstop; k++)
         {
         for (i = 1; i <= Nidelt; i++)
            {
            for (j = 0; j <= var_148 - 1; j++)
               {
               arr_332[j,i,k] = FileReadNumber(fh);
               arr_336[j,i,k] = FileReadNumber(fh);
               arr_316[j,i,k] = FileReadNumber(fh);
               }
            }
         }
      }
   FileClose(fh);
   }

if ((var_156 > 10) && ((TimeCurrent() >= var_236) || (var_232 == 1)))
   {
   var_156 = 0;
   FileName = "FD_" + Symbol();
   fh = FileOpen(FileName,FILE_CSV|FILE_WRITE);
   FileWrite(fh,"1");
   FileWrite(fh,TimeCurrent());
   for (k = 1; k <= Nstop; k++)
      {
      for (i = 1; i <= Nidelt; i++)
         {
         for (j = 0; j <= var_148 - 1; j++)
            {
            FileWrite(fh,arr_332[j,i,k]);
            FileWrite(fh,arr_336[j,i,k]);
            FileWrite(fh,arr_316[j,i,k]);
            }
         }
      }
   FileClose(fh);
   }

ordtotal = OrdersTotal();
var_196 = 0;

for (j = 0; j < ordtotal; j++)
   {
   if (MyOrder(j)) var_196++;
   }

if (var_196 == 0)
   {
   if ((NeedModifyBuy == 1) && (MathAbs(var_260 - Ask) > 10 * Point))
      {
      OrderNew(OP_BUY);
      return(0);
      }
   if ((NeedModifySell == 1) && (MathAbs(var_268 - Bid) > 10 * Point))
      {
      OrderNew(OP_SELL);
      return(0);
      }
   }

if (var_196 == 1)
   {
   ordtotal = OrdersTotal();
   for (j = 0; j < ordtotal; j++)
      {
      if (MyOrder(j))
         {
         if (OrderType() == OP_SELL)
            {
            if ((NeedModifyBuy == 1) && (MathAbs(var_268 - Bid) > 10 * Point))
               {
               OrderNew(OP_BUY);
               return(0);
               }
            }
         if (OrderType() == OP_BUY)
            {
            if ((NeedModifySell == 1) && (MathAbs(var_260 - Ask) > 10 * Point))
               {
               OrderNew(OP_SELL);
               return(0);
               }
            }
         }
      }
   }

ordtotal = OrdersTotal();

for (j = 0; j < ordtotal; j++)
   {
   if (MyOrder(j))
      {
      if ((OrderType() == OP_BUY) && (NeedModifyBuy == 1) && (Bid - OrderStopLoss() > StopLoss * Point))
         {
         OrderModify(OrderTicket(),OrderOpenPrice(),Bid - StopLoss * Point,Bid + TakeProfit * Point,0,Orange);
         return(0);
         }
      if ((OrderType() == OP_SELL) && (NeedModifySell == 1) && (OrderStopLoss() - Ask > StopLoss * Point))
         {
         OrderModify(OrderTicket(),OrderOpenPrice(),Ask + StopLoss * Point,Ask - TakeProfit * Point,0,Red);
         return(0);
         }
      }
   }

ordtotal = OrdersTotal();

for (j = 0; j < ordtotal; j++)
   {
   if (MyOrder(j))
      {
      if (OrderType() == OP_BUY)
         {
         NeedModifyBuy = 0;
         var_276 = TimeCurrent();
         var_260 = OrderOpenPrice();
         }
      if (OrderType() == OP_SELL)
         {
         NeedModifySell = 0;
         var_284 = TimeCurrent();
         var_268 = OrderOpenPrice();
         }
      }
   }

ordtotal = OrdersTotal();

for (j = 0; j < ordtotal; j++)
   {
   if (MyOrder(j))
      {
      if ((NeedCloseBuy == 1) && (OrderType() == OP_BUY))
         {
         OrderClose(OrderTicket(),OrderLots(),Bid,3,Orange);
         return(0);
         }
      if ((NeedCloseSell == 1) && (OrderType() == OP_SELL))
         {
         OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
         return(0);
         }
      }
   }

var_220 = 0;
var_224 = 0;

ordtotal = OrdersTotal();

for (j = 0; j < ordtotal; j++)
   {
   if (MyOrder(j))
      {
      if (OrderType() == OP_BUY) var_220 = 1;
      if (OrderType() == OP_SELL) var_224 = 1;
      }
   }

if (var_220 == 0) NeedCloseBuy = 0;
if (var_224 == 0) NeedCloseSell = 0;

ordtotal = OrdersTotal();

for (j = 0; j < ordtotal; j++)
   {
   if (MyOrder(j))
      {
      if ((OrderType() == OP_BUY) && (var_192 > 10))
         {
         if (OrderStopLoss() < Bid - Point * var_192)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),Bid - Point * var_192,Bid + Point * var_192,0,Orange);
            }
         }
      if ((OrderType() == OP_SELL) && (var_192 > 10))
         {
         if (OrderStopLoss() > Ask + Point * var_192)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),Ask + Point * var_192,Ask - Point * var_192,0,Red);
            }
         }
      }
   }
}

//+------------------------------------------------------------------+

void OrderNew(int ordtype)
{
if (ordtype == OP_BUY)
   {
   ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask - StopLoss * Point,Ask + TakeProfit * Point,"AT",Magic,0,Blue);
   if (ticket < 0)
      Print(" OrderSend() Error: ",GetLastError());
         else
      Print("Trying to open BUY price: ",Ask," Stop ",Ask - StopLoss * Point," TP ",Point,Ask + TakeProfit * Point);
   }
      else
   {
   ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid + StopLoss * Point,Bid - TakeProfit * Point,"AT",Magic,0,Red);
   if (ticket < 0)
      Print(" OrderSend() Error: ",GetLastError());
         else
      Print("Trying to open SELL price: ",Bid," Stop ",Bid + StopLoss * Point," TP ",Bid - TakeProfit * Point);
   }
}

//+------------------------------------------------------------------+

bool MyOrder(int pos)
{
return(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic));
}
